# md_notes
#
# This file was automatically generated by APIMATIC v2.0
# ( https://apimatic.io ).

module MdNotes
  # An enum for SDK environments.
  class Environment
    ENVIRONMENT = [
      PRODUCTION = 'production'.freeze
    ].freeze
  end

  # An enum for API servers.
  class Server
    SERVER = [
      DEFAULT = 'default'.freeze
    ].freeze
  end

  # All configuration including auth info and base URI for the API access
  # are configured in this class.
  class Configuration
    # The attribute readers for properties.
    attr_reader :http_client
    attr_reader :timeout
    attr_reader :max_retries
    attr_reader :retry_interval
    attr_reader :backoff_factor
    attr_reader :retry_statuses
    attr_reader :retry_methods
    attr_reader :environment
    attr_reader :o_auth_client_id
    attr_reader :o_auth_client_secret
    attr_reader :o_auth_username
    attr_reader :o_auth_password

    def o_auth_token
      if @o_auth_token.is_a? OAuthToken
        OAuthToken.from_hash @o_auth_token.to_hash
      else
        @o_auth_token
      end
    end

    class << self
      attr_reader :environments
    end

    def initialize(timeout: 60, max_retries: 0, retry_interval: 1,
                   backoff_factor: 2,
                   retry_statuses: [408, 413, 429, 500, 502, 503, 504, 521, 522, 524],
                   retry_methods: %i[get put],
                   environment: Environment::PRODUCTION,
                   o_auth_client_id: 'TODO: Replace',
                   o_auth_client_secret: 'TODO: Replace',
                   o_auth_username: 'TODO: Replace',
                   o_auth_password: 'TODO: Replace', o_auth_token: nil)
      # The value to use for connection timeout
      @timeout = timeout

      # The number of times to retry an endpoint call if it fails
      @max_retries = max_retries

      # Pause in seconds between retries
      @retry_interval = retry_interval

      # The amount to multiply each successive retry's interval amount
      # by in order to provide backoff
      @backoff_factor = backoff_factor

      # A list of HTTP statuses to retry
      @retry_statuses = retry_statuses

      # A list of HTTP methods to retry
      @retry_methods = retry_methods

      # Current API environment
      @environment = String(environment)

      # OAuth 2 Client ID
      @o_auth_client_id = o_auth_client_id

      # OAuth 2 Client Secret
      @o_auth_client_secret = o_auth_client_secret

      # OAuth 2 Resource Owner Username
      @o_auth_username = o_auth_username

      # OAuth 2 Resource Owner Password
      @o_auth_password = o_auth_password

      # Object for storing information about the OAuth token
      @o_auth_token = if o_auth_token.is_a? OAuthToken
                        OAuthToken.from_hash o_auth_token.to_hash
                      else
                        o_auth_token
                      end

      # The Http Client to use for making requests.
      @http_client = create_http_client
    end

    def clone_with(timeout: nil, max_retries: nil, retry_interval: nil,
                   backoff_factor: nil, retry_statuses: nil, retry_methods: nil,
                   environment: nil, o_auth_client_id: nil,
                   o_auth_client_secret: nil, o_auth_username: nil,
                   o_auth_password: nil, o_auth_token: nil)
      timeout ||= self.timeout
      max_retries ||= self.max_retries
      retry_interval ||= self.retry_interval
      backoff_factor ||= self.backoff_factor
      retry_statuses ||= self.retry_statuses
      retry_methods ||= self.retry_methods
      environment ||= self.environment
      o_auth_client_id ||= self.o_auth_client_id
      o_auth_client_secret ||= self.o_auth_client_secret
      o_auth_username ||= self.o_auth_username
      o_auth_password ||= self.o_auth_password
      o_auth_token ||= self.o_auth_token

      Configuration.new(timeout: timeout, max_retries: max_retries,
                        retry_interval: retry_interval,
                        backoff_factor: backoff_factor,
                        retry_statuses: retry_statuses,
                        retry_methods: retry_methods, environment: environment,
                        o_auth_client_id: o_auth_client_id,
                        o_auth_client_secret: o_auth_client_secret,
                        o_auth_username: o_auth_username,
                        o_auth_password: o_auth_password,
                        o_auth_token: o_auth_token)
    end

    def create_http_client
      FaradayClient.new(timeout: timeout, max_retries: max_retries,
                        retry_interval: retry_interval,
                        backoff_factor: backoff_factor,
                        retry_statuses: retry_statuses,
                        retry_methods: retry_methods)
    end

    # All the environments the SDK can run in.
    ENVIRONMENTS = {
      Environment::PRODUCTION => {
        Server::DEFAULT => 'http://markdown-notes-app.herokuapp.com'
      }
    }.freeze

    # Generates the appropriate base URI for the environment and the server.
    # @param [Configuration::Server] The server enum for which the base URI is
    # required.
    # @return [String] The base URI.
    def get_base_uri(server = Server::DEFAULT)
      ENVIRONMENTS[environment][server].clone
    end
  end
end
